<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'product_category';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/product/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 款式属性模块
if ($_OPEN['attribute']) {
    include_once (ROOT_PATH . 'include/attribute.class.php');
    $dou_attribute = new douAttribute();
}

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 款式属性列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['attribute']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['attribute_add'],
            'href' => 'attribute.php?rec=add' 
    ));
 
    // 获取参数
    $cat_id = $check->is_number($_REQUEST['cat_id']) ? $_REQUEST['cat_id'] : '';
 
    if ($cat_id)
        $where = ' WHERE cat_id = 0 OR cat_id IN (' . $cat_id . $dou->dou_child_id('product_category', $cat_id) . ')';
    
    $sql = "SELECT * FROM " . $dou->table('attribute') . $where . " ORDER BY sort ASC, att_id ASC";
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $cat_name = $dou->get_one("SELECT cat_name FROM " . $dou->table('product_category') . " WHERE cat_id = '$row[cat_id]'");
        $attribute_list[] = array (
                "att_id" => $row['att_id'],
                "cat_id" => $row['cat_id'],
                "cat_name" => $cat_name ? $cat_name : $_LANG['attribute_category_all'],
                "name" => $row['name'],
                "type" => $_LANG['attribute_type_' . $row['type']],
                "sort" => $row['sort']
        );
    }
    
    // 赋值给模板
    $smarty->assign('attribute_list', $attribute_list);
    
    $smarty->display('attribute.htm');
} 

/**
 * +----------------------------------------------------------
 * 款式属性添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['attribute_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['attribute'],
            'href' => 'attribute.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('product_category', $dou->get_category_nolevel('product_category'));
    
    $smarty->display('attribute.htm');
} 

elseif ($rec == 'insert') {
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['attribute_name'] . $_LANG['is_empty']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('attribute') . " (att_id, cat_id, name, type, sort)" . " VALUES (NULL, '$_POST[cat_id]', '$_POST[name]', '$_POST[type]', '$_POST[sort]')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['attribute_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['attribute_add_succes'], 'attribute.php');
} 

/**
 * +----------------------------------------------------------
 * 款式属性编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['attribute_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['attribute'],
            'href' => 'attribute.php' 
    ));
    
    // 获取款式属性信息
    $att_id = $check->is_number($_REQUEST['att_id']) ? $_REQUEST['att_id'] : '';
    $attribute = $dou->get_row('attribute', '*', "att_id = '$att_id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('product_category', $dou->get_category_nolevel('product_category'));
    $smarty->assign('attribute', $attribute);
    
    $smarty->display('attribute.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $att_id = $check->is_number($_POST['att_id']) ? $_POST['att_id'] : '';
    
    if (empty($_POST['name']))
        $dou->dou_msg($_LANG['attribute_name'] . $_LANG['is_empty']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "update " . $dou->table('attribute') . " SET cat_id = '$_POST[cat_id]', name = '$_POST[name]', type = '$_POST[type]', sort = '$_POST[sort]' WHERE att_id = '$att_id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['attribute_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['attribute_edit_succes'], 'attribute.php');
} 

/**
 * +----------------------------------------------------------
 * 值添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'value') {
    // 验证并获取合法的REQUEST
    $act = $check->is_rec($_REQUEST['act']) ? $_REQUEST['act'] : 'add';
 
    // 验证并获取合法的ID
    if ($act == 'add') {
        $module = $check->is_letter($_REQUEST['module']) ? $_REQUEST['module'] : exit;
        $item_id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : exit;
        $att_id = $check->is_number($_REQUEST['att_id']) ? $_REQUEST['att_id'] : exit;
        $value = !$check->is_illegal_char($_REQUEST['value']) ? $_REQUEST['value'] : '';
        $remark = !$check->is_illegal_char($_REQUEST['remark']) ? $_REQUEST['remark'] : '';
        $price_change = preg_match("/^[0-9-]+$/", $_REQUEST['price_change']) ? $_REQUEST['price_change'] : '';
        $attribute = $dou->get_row('attribute', '*', "att_id = '$att_id'");
     
        if (!$value) {
            $data['wrong'] = $_LANG['attribute_value_value'] . $_LANG['is_empty'];
        } else {
            // 如果是该属性第一个值，不允许设置价格浮动，因为要跟初始价格保持同步
            if (!$dou->value_exist('attribute_value', 'att_id', $att_id, "module = '$module' AND item_id = '$item_id'") && $price_change > 0) {
                $data['wrong'] = $_LANG['attribute_value_price_cue'];
            } else {
                // 同一个属性不允许输入重复的值
                if (!$dou->value_exist('attribute_value', 'value', $value, "module = '$module' AND item_id = '$item_id' AND att_id = '$att_id'")) {
                    $dou->query("INSERT INTO " . $dou->table('attribute_value') . " (id, module, item_id, att_id, type, value, remark, price_change)" . " VALUES (NULL, '$module', '$item_id', '$att_id', '$attribute[type]', '$value', '$remark', '$price_change')");
                } else {
                    $data['wrong'] = $attribute['name'] . $_LANG['is_exist'];
                }
            }
        }

        $data['html'] = $dou_attribute->get_value_list($module, $item_id, $att_id, 'html');
    }

    // 删除
    elseif ($act == 'del') {
        $module = $check->is_letter($_REQUEST['module']) ? $_REQUEST['module'] : exit;
        $item_id = $check->is_number($_REQUEST['item_id']) ? $_REQUEST['item_id'] : exit;
        $att_id = $check->is_number($_REQUEST['att_id']) ? $_REQUEST['att_id'] : exit;
        $del_value = !$check->is_illegal_char($_REQUEST['del_value']) ? $_REQUEST['del_value'] : '';
     
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('attribute_value') . " WHERE module = '$module' AND item_id = '$item_id' AND att_id = '$att_id' AND value = '$del_value'");
        $dou->del_file($image);
     
        $dou->delete('attribute_value', "module = '$module' AND item_id = '$item_id' AND att_id = '$att_id' AND value = '$del_value'");
     
        $data['html'] = $dou_attribute->get_value_list($module, $item_id, $att_id, 'html');
    }

    // 添加图片
    elseif ($act == 'image') {
        // 验证并获取合法的REQUEST
        $value_id = $check->is_number($_REQUEST['value_id']) ? $_REQUEST['value_id'] : exit;
        $type = $check->is_letter($_REQUEST['type']) ? $_REQUEST['type'] : '';
        $img_width = 500;
        $value = $dou->get_row('attribute_value', '*', "id = '$value_id'");

        // 文件上传盒子
        $custom_filename = $value['item_id'] . '_attribute_' . $dou->create_rand_string('number', 6, time());
        $image = $file->box('attribute_value', $item_id, 'image', 'main', $custom_filename, '', '', $img_width, $_CFG['watermark']);
     
        $dou->query("UPDATE " . $dou->table('attribute_value') . " SET image = '$image' WHERE id = '$value_id'");
        
        $data['html'] = $dou_attribute->get_value_list($value['module'], $value['item_id'], $value['att_id'], 'html');
    }

    echo json_encode($data);
} 

/**
 * +----------------------------------------------------------
 * 分类删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    $att_id = $check->is_number($_REQUEST['att_id']) ? $_REQUEST['att_id'] : $dou->dou_msg($_LANG['illegal'], 'attribute.php');
    $name = $dou->get_one("SELECT name FROM " . $dou->table('attribute') . " WHERE att_id = '$att_id'");
    $is_parent = $dou->get_one("SELECT id FROM " . $dou->table('attribute_value') . " WHERE att_id = '$att_id'");
    
    if ($is_parent) {
        $_LANG['attribute_del_is_parent'] = preg_replace('/d%/Ums', $name, $_LANG['attribute_del_is_parent']);
        $dou->dou_msg($_LANG['attribute_del_is_parent'], 'attribute.php', '', '3');
    } else {
        if (isset($_POST['confirm'])) {
            $dou->create_admin_log($_LANG['attribute_del'] . ': ' . $name);
            $dou->delete('attribute', "att_id = $att_id", 'attribute.php');
        } else {
            $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
            $dou->dou_msg($_LANG['del_check'], 'attribute.php', '', '30', "attribute.php?rec=del&att_id=$att_id");
        }
    }
}

?>